Loading...
Searching...
No Matches
casacore::Vector< T > Class Template Reference
casa package (libcasa_casa) » Arrays_module

More...

`#include <Vector.h>`

## Public Member Functions

| Vector ()
| A zero-length Vector.
| Vector (size_t Length)
| A Vector with a defined length and origin of zero.
| Vector (const IPosition &Length)
| Vector (size_t Length, const T &initialValue)
| A Vector with a defined length and origin of zero.
| Vector (const IPosition &Length, const T &initialValue)
| Vector (size_t Length, typename Array< T >::uninitializedType)
| An uninitialized Vector with a defined length.
| Vector (const IPosition &Length, typename Array< T >::uninitializedType)
| Vector (const std::vector< T > &other, long long nr)
| Create a Vector from the given std::vector "other." Make it length "nr" and copy over that many elements.
| Vector (const std::vector< T > &other)
| Create a Vector of length other.size() and copy over its values.
| Vector (std::initializer_list< T > list)
| Create a Vector from an initializer list.
| Vector (const Vector< T > &other)
| Create a reference to other.
| Vector (Vector< T > &&source) noexcept
| Move.
| Vector (const Array< T > &other)
| Create a reference to the other array.
| Vector (const IPosition &shape, T *storage, StorageInitPolicy policy=COPY)
| Create an Vector of a given shape from a pointer.
| Vector (const IPosition &shape, const T *storage)
| Create an Vector of a given shape from a pointer.
template<typename InputIterator>
| Vector (InputIterator startIter, InputIterator endIter)
template<typename U, typename V>
| Vector (const std::vector< U, V > &other)
| Create a Vector from an STL vector (see tovector() in Array for the reverse operation).
template<typename Iterator>
| Vector (Iterator first, size_t size, int dummy)
| Create a Vector from a container iterator and its length.
void | resize (size_t len, bool copyValues=false)
virtual void | resize (const IPosition &len, bool copyValues=false) final override
| Resize the array and optionally copy the values.
Vector< T > & | assign_conforming (const Vector< T > &source)
Vector< T > & | assign_conforming (Vector< T > &&source)
Vector< T > & | assign_conforming (const Array< T > &source)
| source must be a 1-dimensional array.
Vector< T > & | assign_conforming (Array< T > &&source)
Vector< T > & | operator= (const Vector< T > &source)
Vector< T > & | operator= (Vector< T > &&source)
Vector< T > & | operator= (const Array< T > &source)
Vector< T > & | operator= (Array< T > &&source)
T & | operator[] (size_t index)
| Convert a Vector to a Block, resizing the block and copying values.
const T & | operator[] (size_t index) const
T & | operator() (const IPosition &i)
const T & | operator() (const IPosition &i) const
T & | operator() (size_t index)
const T & | operator() (size_t index) const
Vector< T > | operator() (const Slice &slice)
| Take a slice of this vector.
const Vector< T > | operator() (const Slice &slice) const
Array< T > | operator() (const IPosition &blc, const IPosition &trc, const IPosition &incr)
| Slice using IPositions.
const Array< T > | operator() (const IPosition &blc, const IPosition &trc, const IPosition &incr) const
Array< T > | operator() (const IPosition &blc, const IPosition &trc)
const Array< T > | operator() (const IPosition &blc, const IPosition &trc) const
Array< T > | operator() (const Slicer &slicer)
const Array< T > | operator() (const Slicer &slicer) const
MaskedArray< T > | operator() (const LogicalArray &mask) const
| The array is masked by the input LogicalArray.
MaskedArray< T > | operator() (const LogicalArray &mask)
| Return a MaskedArray.
MaskedArray< T > | operator() (const MaskedLogicalArray &mask) const
| The array is masked by the input MaskedLogicalArray.
MaskedArray< T > | operator() (const MaskedLogicalArray &mask)
| Return a MaskedArray.
const IPosition & | shape () const
| The length of the Vector.
void | shape (int &Shape) const
virtual bool | ok () const final override
| Verify that dimensionality is 1 and then call Array<T>::ok().
Public Member Functions inherited from casacore::Array< T >
| Array ()
| Result has dimensionality of zero, and nelements is zero.
| Array (const IPosition &shape)
| Create an array of the given shape, i.e.
| Array (const IPosition &shape, const T &initialValue)
| Create an array of the given shape and initialize it with the initial value.
| Array (const IPosition &shape, uninitializedType)
| Constructor to create an uninitialized array.
| Array (std::initializer_list< T > list)
| Construct a one-dimensional array from an initializer list.
| Array (const Array< T > &other)
| After construction, this and other reference the same storage.
| Array (Array< T > &&source) noexcept
| Source will be empty after this call.
| Array (const IPosition &shape, T *storage, StorageInitPolicy policy=COPY)
| Create an Array of a given shape from a pointer.
| Array (const IPosition &shape, const T *storage)
| Create an Array of a given shape from a pointer.
template<typename InputIterator>
| Array (const IPosition &shape, InputIterator startIter)
| Construct an array from an iterator and a shape.
virtual | ~Array () noexcept
| Frees up storage only if this array was the last reference to it.
virtual std::unique_ptr< ArrayBase > | makeArray () const override
| Make an empty array of the same template type.
void | assign (const Array< T > &other)
| Assign the other array to this array.
void | assignBase (const ArrayBase &other, bool checkType=true) override
| Assign the source array to this array.
void | set (const T &value)
| Set every element of the array to "value." Also could use the assignment operator which assigns an array from a scalar.
template<typename Callable>
void | apply (Callable function)
| Apply the function to every element of the array.
virtual void | reference (const Array< T > &other)
| After invocation, this array and other reference the same storage.
Array< T > & | assign_conforming (const Array< T > &other)
| Copy the values in other to this.
Array< T > & | assign_conforming (const MaskedArray< T > &marray)
| Copy to this those values in marray whose corresponding elements in marray's mask are true.
Array< T > & | operator= (const Array< T > &other)
| TODO we should change the semantics.
Array< T > & | operator= (const MaskedArray< T > &marray)
| Calls assign_conforming().
Array< T > & | operator= (Array< T > &&other)
| The move operator takes the storage from the given array.
Array< T > & | operator= (const T &value)
| Set every element of this array to "value".
Array< T > | copy () const
| This makes a copy of the array and returns it.
void | copyMatchingPart (const Array< T > &from)
| This function copies the matching part of from array to this array.
void | unique ()
| This ensures that this array does not reference any other storage.
template<class U>
void | tovector (std::vector< T, U > &out) const
| Create an STL vector from an Array.
std::vector< T > | tovector () const
Array< T > | reform (const IPosition &shape) const
| It is occasionally useful to have an array which access the same storage appear to have a different shape.
bool | reformOrResize (const IPosition &newShape, size_t resizePercentage=0, bool resizeIfNeeded=true)
| Having an array that can be reused without requiring reallocation can be useful for large arrays.
bool | adjustLastAxis (const IPosition &newShape, size_t resizePercentage=0, bool resizeIfNeeded=true)
| Use this method to extend or reduce the last dimension of an array.
size_t | capacity () const
| Returns the number of elements allocated.
Array< T > | nonDegenerate (size_t startingAxis=0, bool throwIfError=true) const
| These member functions remove degenerate (ie.
Array< T > | nonDegenerate (const IPosition &ignoreAxes) const
void | nonDegenerate (const Array< T > &other, size_t startingAxis=0, bool throwIfError=true)
void | nonDegenerate (const Array< T > &other, const IPosition &ignoreAxes)
void | removeDegenerate (size_t startingAxis=0, bool throwIfError=true)
| Remove degenerate axes from this Array object.
void | removeDegenerate (const IPosition &ignoreAxes)
const Array< T > | addDegenerate (size_t numAxes) const
| This member function returns an Array reference with the specified number of extra axes, all of length one, appended to the end of the Array.
Array< T > | addDegenerate (size_t numAxes)
void | resize ()
| Make this array a different shape.
T & | operator() (const IPosition &)
| Access a single element of the array.
const T & | operator() (const IPosition &) const
Array< T > | operator() (const IPosition &start, const IPosition &end)
| Get a reference to an array section extending from start to end (inclusive).
const Array< T > | operator() (const IPosition &start, const IPosition &end) const
Array< T > | operator() (const IPosition &start, const IPosition &end, const IPosition &inc)
| Along the ith axis, every inc[i]'th element is chosen.
const Array< T > | operator() (const IPosition &start, const IPosition &end, const IPosition &inc) const
Array< T > | operator() (const Slicer &)
| Get a reference to an array section using a Slicer.
const Array< T > | operator() (const Slicer &) const
std::unique_ptr< ArrayBase > | getSection (const Slicer &) const override
| Get a reference to a section of an array.
Array< T > | operator[] (size_t i) const
| Get the subset given by the i-th value of the last axis.
Array< T > | diagonals (size_t firstAxis=0, long long diag=0) const
| Get the diagonal of each matrix part in the full array.
const MaskedArray< T > | operator() (const LogicalArray &mask) const
| The array is masked by the input LogicalArray.
MaskedArray< T > | operator() (const LogicalArray &mask)
const MaskedArray< T > | operator() (const MaskedLogicalArray &mask) const
| The array is masked by the input MaskedLogicalArray.
MaskedArray< T > | operator() (const MaskedLogicalArray &mask)
size_t | nrefs () const
| The number of references the underlying storage has assigned to it.
bool | conform (const Array< T > &other) const
| Are the shapes identical?
bool | conform (const MaskedArray< T > &other) const
T * | data ()
| Get a pointer to the beginning of the array.
const T * | data () const
T * | getStorage (bool &deleteIt)
| Generally use of this should be shunned, except to use a FORTRAN routine or something similar.
const T * | getStorage (bool &deleteIt) const
void * | getVStorage (bool &deleteIt) override
| The following functions behave the same as the corresponding getStorage functions in the derived templated Array class.
const void * | getVStorage (bool &deleteIt) const override
void | putStorage (T *&storage, bool deleteAndCopy)
| putStorage() is normally called after a call to getStorage() (cf).
void | putVStorage (void *&storage, bool deleteAndCopy) override
void | freeStorage (const T *&storage, bool deleteIt) const
| If deleteIt is set, delete "storage".
void | freeVStorage (const void *&storage, bool deleteIt) const override
virtual void | takeStorage (const IPosition &shape, T *storage, StorageInitPolicy policy=COPY)
| Replace the data values with those in the pointer storage.
virtual void | takeStorage (const IPosition &shape, const T *storage)
| Since the pointer is const, a copy is always taken.
std::unique_ptr< ArrayPositionIterator > | makeIterator (size_t byDim) const override
| Create an ArrayIterator object of the correct type.
iterator | begin ()
| Get the begin iterator object for any array.
const_iterator | begin () const
iterator | end ()
const_iterator | end () const
contiter | cbegin ()
| Get the begin iterator object for a contiguous array.
const_contiter | cbegin () const
contiter | cend ()
const_contiter | cend () const
Public Member Functions inherited from casacore::ArrayBase
| ArrayBase () noexcept
| ArrayBase (const IPosition &shape)
| Create an array of the given shape, i.e.
| ArrayBase (const ArrayBase &other)
| Copy constructor.
| ArrayBase (ArrayBase &&source) noexcept
ArrayBase & | assign (const ArrayBase &)
| Assignment.
ArrayBase & | operator= (const ArrayBase &)=delete
ArrayBase & | operator= (ArrayBase &&) noexcept
virtual | ~ArrayBase () noexcept
| Destructor.
size_t | ndim () const
| The dimensionality of this array.
size_t | nelements () const
| How many elements does this array have?
size_t | size () const
bool | empty () const
| Is the array empty (i.e.
bool | contiguousStorage () const
| Are the array data contiguous?
const IPosition & | shape () const
| The length of each axis.
IPosition | endPosition () const
| A convenience function: endPosition(i) = shape(i) - 1; i.e.
const IPosition & | steps () const
| Return steps to be made if stepping one element in a dimension.
void | validateConformance (const ArrayBase &) const
| Various helper functions.
void | validateIndex (const IPosition &) const
void | validateIndex (size_t index) const
void | validateIndex (size_t index1, size_t index2) const
void | validateIndex (size_t index1, size_t index2, size_t index3) const

## Protected Member Functions

virtual void | doNonDegenerate (const Array< T > &other, const IPosition &ignoreAxes) final override
| Remove the degenerate axes from other and store result in this vector.
virtual size_t | fixedDimensionality () const final override
| Subclasses can return their dimensionality.
Protected Member Functions inherited from casacore::Array< T >
| Array (Array< T > &&source, const IPosition &shapeForSource) noexcept
| Source will be empty with given shape after this call.
void | swap (Array< T > &other)
| Swap this array with another array.
virtual void | preTakeStorage (const IPosition &)
| pre/post processing hook of takeStorage() for subclasses.
virtual void | postTakeStorage ()
void | checkBeforeResize (const IPosition &newShape)
| This function is called when this array is about to be resized, before any work is done.
virtual void | checkAssignableType (ArrayBase &arrayBase) const
void | makeSteps ()
| Fill the steps and the end for a derived class.
void | setEndIter ()
| Set the end iterator.
Protected Member Functions inherited from casacore::ArrayBase
| ArrayBase (ArrayBase &&source, const IPosition &shapeForSource) noexcept
| For subclasses, this move constructor allows the moved-from object to obtain a given shape after resizing.
void | swap (ArrayBase &source) noexcept
bool | reformOrResize (const IPosition &newShape, bool resizeIfNeeded, size_t nReferences, long long nElementsAllocated, bool copyDataIfNeeded, size_t resizePercentage)
| Either reforms the array if size permits or resizes it to the new shape.
bool | isStorageContiguous () const
| Determine if the storage of a subset is contiguous.
void | checkVectorShape ()
| Check if the shape of a vector is correct.
void | checkMatrixShape ()
| Check if the shape of a matrix is correct.
void | checkCubeShape ()
| Check if the shape of a cube is correct.
void | baseReform (ArrayBase &tmp, const IPosition &shape, bool strict=true) const
| Reform the array to a shape with the same nr of elements.
void | baseNonDegenerate (const ArrayBase &other, const IPosition &ignoreAxes)
| Remove the degenerate axes from the Array object.
void | baseAddDegenerate (ArrayBase &, size_t numAxes)
| These member functions return an Array reference with the specified number of extra axes, all of length one, appended to the end of the Array.
size_t | makeSubset (ArrayBase &out, const IPosition &b, const IPosition &e, const IPosition &i)
| Make a subset of an array.
size_t | makeDiagonal (size_t firstAxis, long long diag)
| Set the length and stride such that the diagonal of the matrices defined by two consecutive axes is formed.
bool | conform2 (const ArrayBase &other) const
| Are the shapes identical?
void | baseMakeSteps ()
| Make the indexing step sizes.
bool | copyVectorHelper (const ArrayBase &other)
| Helper function for templated Vector class.

## Private Member Functions

Vector< T > & | assign_conforming_implementation (const Vector< T > &v, std::false_type isCopyable)
Vector< T > & | assign_conforming_implementation (const Vector< T > &v, std::true_type isCopyable)
void | initVector (const std::vector< T > &, long long nr)
| Helper functions for constructors.
template<typename InputIterator>
| Vector (InputIterator startIter, InputIterator endIter, std::false_type)
| The following two constructors are used to make distinguish between Vector<literal>(literal size, literal value) and Vector<literal>(iterator, iterator).
template<typename InputIterator>
| Vector (InputIterator startIter, InputIterator endIter, std::true_type)

## Additional Inherited Members

Public Types inherited from casacore::Array< T >
typedef T | value_type
| Define the STL-style iterator functions (only forward iterator).
typedef const T & | const_reference
| TODO This is how std containers define a reference type, but the name 'reference' is already taken by a method.
typedef T * | pointer
| Pointer to an element type.
typedef const T * | const_pointer
| Constant pointer to the element type.
typedef IteratorSTL | iterator
typedef ConstIteratorSTL | const_iterator
typedef T * | contiter
typedef const T * | const_contiter
Static Public Member Functions inherited from casacore::ArrayBase
static unsigned | arrayVersion ()
| Array version for major change (used by ArrayIO).
Static Public Attributes inherited from casacore::Array< T >
static struct casacore::Array::uninitializedType | uninitialized
Static Protected Member Functions inherited from casacore::Array< T >
static void | copyToContiguousStorage (T *dst, Array< T > const &src)
Protected Attributes inherited from casacore::Array< T >
std::shared_ptr< arrays_internal::Storage< T > > | data_p
| Shared pointer to a Storage that contains the data.
T * | begin_p
| This pointer is adjusted to point to the first element of the array.
T * | end_p
| The end for an STL-style iteration.
Protected Attributes inherited from casacore::ArrayBase
size_t | nels_p
| Number of elements in the array.
size_t | ndimen_p
| Dimensionality of the array.
bool | contiguous_p
| Are the data contiguous?
IPosition | length_p
| Used to hold the shape, increment into the underlying storage and originalLength of the array.
IPosition | inc_p
IPosition | originalLength_p
IPosition | steps_p
| Used to hold the step to next element in each dimension.

## Detailed Description

template<typename T>
class casacore::Vector< T >

A 1-D Specialization of the Array class

### Review Status

Reviewed By:
  UNKNOWN
Date Reviewed:
  before2004/08/25

Vector objects are one-dimensional specializations (e.g., more convenient and efficient indexing) of the general Array class. You might also want to look at the Array documentation to see inherited functionality.

Generally the member functions of Array are also available in Vector versions which take an integer where the array needs an IPosition. Since the Vector is one-dimensional, the IPositions are overkill, although you may use those versions if you want to.

Vector<int> vi(100); // Vector 100 elements long.
vi.resize(50); // Now only 50 long.
casacore::Vector::Vector
Vector()
A zero-length Vector.

Slices may be taken with the Slice class. To take a slice, one "indexes" with Slice(start, length, inc) where end and inc are optional.

Vector<float> vf(100);
//..\.
vf(Slice(0,50,2)) = vf(Slice(1,50,2)); // Copy values from odd onto even
Vector<float> firstHalf, secondHalf;
firstHalf.reference(vf(Slice(0,50)));
secondHalf.reference(vf(Slice(50,50)));
// Now we have aliases for two slices into the Vector
casacore::Array::reference
virtual void reference(const Array< T > &other)
After invocation, this array and other reference the same storage.
casacore::Slice
Definition Slice.h:89

Element-by-element arithmetic and logical operations are available (in aips/ArrayMath.h and aips/ArrayLogical.h) as well as dot and cross products (in aips/MatrixMath.h).

A Vector can be constructed from an STL vector. The reverse operation (Array::tovector()) can construct an STL vector from any Array.
Tip: To create any other STL container from an Array (or the reverse), always create from/to a vector, and use the range constructor to create from/to others (like set, list, deque);

As with the Arrays, if the preprocessor symbol AIPS_DEBUG is defined at compile time invariants will be checked on entry to most member functions. Additionally, if AIPS_ARRAY_INDEX_CHECK is defined index operations will be bounds-checked. Neither of these should be defined for production code.

Definition at line 81 of file Vector.h.

## Constructor & Destructor Documentation

## Vector() [1/20]

template<typename T>

casacore::Vector< T >::Vector | ( |  | ) |

A zero-length Vector.

## Vector() [2/20]

template<typename T>

casacore::Vector< T >::Vector | ( | size_t | Length | ) |

explicit

A Vector with a defined length and origin of zero.

## Vector() [3/20]

template<typename T>

casacore::Vector< T >::Vector | ( | const IPosition & | Length | ) |

explicit

## Vector() [4/20]

template<typename T>

casacore::Vector< T >::Vector | ( | size_t | Length,
|  | const T & | initialValue )

A Vector with a defined length and origin of zero.

Fill it with the initial value.

## Vector() [5/20]

template<typename T>

casacore::Vector< T >::Vector | ( | const IPosition & | Length,
|  | const T & | initialValue )

## Vector() [6/20]

template<typename T>

casacore::Vector< T >::Vector | ( | size_t | Length,
|  | typename Array< T >::uninitializedType | )

An uninitialized Vector with a defined length.

## Vector() [7/20]

template<typename T>

casacore::Vector< T >::Vector | ( | const IPosition & | Length,
|  | typename Array< T >::uninitializedType | )

## Vector() [8/20]

template<typename T>

casacore::Vector< T >::Vector | ( | const std::vector< T > & | other,
|  | long long | nr )

Create a Vector from the given std::vector "other." Make it length "nr" and copy over that many elements.

This used to take a 'Block'

## Vector() [9/20]

template<typename T>

casacore::Vector< T >::Vector | ( | const std::vector< T > & | other | ) |

explicit

Create a Vector of length other.size() and copy over its values.

This used to take a 'Block'

## Vector() [10/20]

template<typename T>

casacore::Vector< T >::Vector | ( | std::initializer_list< T > | list | ) |

Create a Vector from an initializer list.

## Vector() [11/20]

template<typename T>

casacore::Vector< T >::Vector | ( | const Vector< T > & | other | ) |

Create a reference to other.

## Vector() [12/20]

template<typename T>

casacore::Vector< T >::Vector | ( | Vector< T > && | source | ) |

noexcept

Move.

## Vector() [13/20]

template<typename T>

casacore::Vector< T >::Vector | ( | const Array< T > & | other | ) |

Create a reference to the other array.

It is always possible if the array has zero or one axes. If it has > 1 axes, it is only possible if the array has at most one axis with length > 1. In that case the degenerated axes are removed.

## Vector() [14/20]

template<typename T>

casacore::Vector< T >::Vector | ( | const IPosition & | shape,
|  | T * | storage,
|  | StorageInitPolicy | policy = COPY )

Create an Vector of a given shape from a pointer.

## Vector() [15/20]

template<typename T>

casacore::Vector< T >::Vector | ( | const IPosition & | shape,
|  | const T * | storage )

Create an Vector of a given shape from a pointer.

Because the pointer is const, a copy is always made.

## Vector() [16/20]

template<typename T>
template<typename InputIterator>

casacore::Vector< T >::Vector | ( | InputIterator | startIter,
|  | InputIterator | endIter )

## Vector() [17/20]

template<typename T>
template<typename U, typename V>

casacore::Vector< T >::Vector | ( | const std::vector< U, V > & | other | ) |

explicit

Create a Vector from an STL vector (see tovector() in Array for the reverse operation).

Tip: Both this constructor and the tovector() are defined in Vector2;cc;
It does implicit promotion/demotion of the type U if different from T.

## Vector() [18/20]

template<typename T>
template<typename Iterator>

casacore::Vector< T >::Vector | ( | Iterator | first,
|  | size_t | size,
|  | int | dummy )

Create a Vector from a container iterator and its length.

Note: The length is used instead of last, because the distance function needed to calculate the length can be expensive;
A third dummy argument is unfortunately needed to avoid ambiguity with another Vector constructor (taking two uInts);

## Vector() [19/20]

template<typename T>
template<typename InputIterator>

casacore::Vector< T >::Vector | ( | InputIterator | startIter,
|  | InputIterator | endIter,
|  | std::false_type | )

private

The following two constructors are used to make distinguish between Vector<literal>(literal size, literal value) and Vector<literal>(iterator, iterator).

## Vector() [20/20]

template<typename T>
template<typename InputIterator>

casacore::Vector< T >::Vector | ( | InputIterator | startIter,
|  | InputIterator | endIter,
|  | std::true_type | )

private

## Member Function Documentation

## assign_conforming() [1/4]

template<typename T>

Vector< T > & casacore::Vector< T >::assign_conforming | ( | Array< T > && | source | ) |

## assign_conforming() [2/4]

template<typename T>

Vector< T > & casacore::Vector< T >::assign_conforming | ( | const Array< T > & | source | ) |

source must be a 1-dimensional array.

## assign_conforming() [3/4]

template<typename T>

Vector< T > & casacore::Vector< T >::assign_conforming | ( | const Vector< T > & | source | ) |

inline

Definition at line 179 of file Vector.h.

Referenced by casacore::Vector< LogicalArrayElem >::operator=(), casacore::Vector< LogicalArrayElem >::operator=(), casacore::Vector< LogicalArrayElem >::operator=(), and casacore::Vector< LogicalArrayElem >::operator=().

## assign_conforming() [4/4]

template<typename T>

Vector< T > & casacore::Vector< T >::assign_conforming | ( | Vector< T > && | source | ) |

## assign_conforming_implementation() [1/2]

template<typename T>

Vector< T > & casacore::Vector< T >::assign_conforming_implementation | ( | const Vector< T > & | v,
|  | std::false_type | isCopyable )

private

Referenced by casacore::Vector< LogicalArrayElem >::assign_conforming().

## assign_conforming_implementation() [2/2]

template<typename T>

Vector< T > & casacore::Vector< T >::assign_conforming_implementation | ( | const Vector< T > & | v,
|  | std::true_type | isCopyable )

private

## doNonDegenerate()

template<typename T>

virtual void casacore::Vector< T >::doNonDegenerate | ( | const Array< T > & | other,
|  | const IPosition & | ignoreAxes )

final override protected virtual

Remove the degenerate axes from other and store result in this vector.

An exception is thrown if removing degenerate axes does not result in a vector.

Reimplemented from casacore::Array< T >.

## fixedDimensionality()

template<typename T>

virtual size_t casacore::Vector< T >::fixedDimensionality | ( |  | ) | const

inline final override protected virtual

Subclasses can return their dimensionality.

The Array class will make sure that whenever it is resized, the dimensionality is checked. Array's constructors do not check the dimensionality, because the subclass hasn't been created yet at that point. Subclasses should therefore make sure to call the constructors appropriately. For classes that return 0, any resize will be allowed.

Reimplemented from casacore::Array< T >.

Definition at line 312 of file Vector.h.

## initVector()

template<typename T>

void casacore::Vector< T >::initVector | ( | const std::vector< T > & | ,
|  | long long | nr )

private

Helper functions for constructors.

## ok()

template<typename T>

virtual bool casacore::Vector< T >::ok | ( |  | ) | const

final override virtual

Verify that dimensionality is 1 and then call Array<T>::ok().

Reimplemented from casacore::Array< T >.

## operator()() [1/16]

template<typename T>

Array< T > casacore::Vector< T >::operator() | ( | const IPosition & | blc,
|  | const IPosition & | trc )

inline

Definition at line 254 of file Vector.h.

## operator()() [2/16]

template<typename T>

const Array< T > casacore::Vector< T >::operator() | ( | const IPosition & | blc,
|  | const IPosition & | trc ) const

inline

Definition at line 256 of file Vector.h.

## operator()() [3/16]

template<typename T>

Array< T > casacore::Vector< T >::operator() | ( | const IPosition & | blc,
|  | const IPosition & | trc,
|  | const IPosition & | incr )

inline

Slice using IPositions.

Required to be defined, otherwise the base class versions are hidden.

Definition at line 248 of file Vector.h.

## operator()() [4/16]

template<typename T>

const Array< T > casacore::Vector< T >::operator() | ( | const IPosition & | blc,
|  | const IPosition & | trc,
|  | const IPosition & | incr ) const

inline

Definition at line 251 of file Vector.h.

## operator()() [5/16]

template<typename T>

T & casacore::Vector< T >::operator() | ( | const IPosition & | i | ) |

inline

Definition at line 211 of file Vector.h.

## operator()() [6/16]

template<typename T>

const T & casacore::Vector< T >::operator() | ( | const IPosition & | i | ) | const

inline

Definition at line 213 of file Vector.h.

## operator()() [7/16]

template<typename T>

MaskedArray< T > casacore::Vector< T >::operator() | ( | const LogicalArray & | mask | ) |

inline

Return a MaskedArray.

Definition at line 273 of file Vector.h.

## operator()() [8/16]

template<typename T>

MaskedArray< T > casacore::Vector< T >::operator() | ( | const LogicalArray & | mask | ) | const

inline

The array is masked by the input LogicalArray.

This mask must conform to the array.

Return a MaskedArray.

Definition at line 269 of file Vector.h.

## operator()() [9/16]

template<typename T>

MaskedArray< T > casacore::Vector< T >::operator() | ( | const MaskedLogicalArray & | mask | ) |

inline

Return a MaskedArray.

Definition at line 290 of file Vector.h.

## operator()() [10/16]

template<typename T>

MaskedArray< T > casacore::Vector< T >::operator() | ( | const MaskedLogicalArray & | mask | ) | const

inline

The array is masked by the input MaskedLogicalArray.

The mask is effectively the AND of the internal LogicalArray and the internal mask of the MaskedLogicalArray. The MaskedLogicalArray must conform to the array.

Return a MaskedArray.

Definition at line 286 of file Vector.h.

## operator()() [11/16]

template<typename T>

Vector< T > casacore::Vector< T >::operator() | ( | const Slice & | slice | ) |

Take a slice of this vector.

Slices are always indexed starting at zero. This uses reference semantics, i.e. changing a value in the slice changes the original.

Vector<double> vd(100);
//..\.
vd(Slice(0,10)) = -1.0; // First 10 elements of vd set to -1

## operator()() [12/16]

template<typename T>

const Vector< T > casacore::Vector< T >::operator() | ( | const Slice & | slice | ) | const

## operator()() [13/16]

template<typename T>

Array< T > casacore::Vector< T >::operator() | ( | const Slicer & | slicer | ) |

inline

Definition at line 258 of file Vector.h.

## operator()() [14/16]

template<typename T>

const Array< T > casacore::Vector< T >::operator() | ( | const Slicer & | slicer | ) | const

inline

Definition at line 260 of file Vector.h.

## operator()() [15/16]

template<typename T>

T & casacore::Vector< T >::operator() | ( | size_t | index | ) |

inline

Definition at line 215 of file Vector.h.

## operator()() [16/16]

template<typename T>

const T & casacore::Vector< T >::operator() | ( | size_t | index | ) | const

inline

Definition at line 223 of file Vector.h.

## operator=() [1/4]

template<typename T>

Vector< T > & casacore::Vector< T >::operator= | ( | Array< T > && | source | ) |

inline

Definition at line 196 of file Vector.h.

## operator=() [2/4]

template<typename T>

Vector< T > & casacore::Vector< T >::operator= | ( | const Array< T > & | source | ) |

inline

Definition at line 194 of file Vector.h.

## operator=() [3/4]

template<typename T>

Vector< T > & casacore::Vector< T >::operator= | ( | const Vector< T > & | source | ) |

inline

Definition at line 190 of file Vector.h.

## operator=() [4/4]

template<typename T>

Vector< T > & casacore::Vector< T >::operator= | ( | Vector< T > && | source | ) |

inline

Definition at line 192 of file Vector.h.

## operator[]() [1/2]

template<typename T>

T & casacore::Vector< T >::operator[] | ( | size_t | index | ) |

inline

Convert a Vector to a Block, resizing the block and copying values.

This is done this way to avoid having the simpler Block class containing dependencies on the Vector class. void toBlock(Block<T> &other) const;

Single-pixel addressing. If AIPS_ARRAY_INDEX_CHECK is defined, bounds checking is performed (not for [])..

Definition at line 207 of file Vector.h.

## operator[]() [2/2]

template<typename T>

const T & casacore::Vector< T >::operator[] | ( | size_t | index | ) | const

inline

Definition at line 209 of file Vector.h.

## resize() [1/2]

template<typename T>

virtual void casacore::Vector< T >::resize | ( | const IPosition & | newShape,
|  | bool | copyValues = false )

final override virtual

Resize the array and optionally copy the values.

The default implementation in ArrayBase throws an exception.

Reimplemented from casacore::Array< T >.

## resize() [2/2]

template<typename T>

void casacore::Vector< T >::resize | ( | size_t | len,
|  | bool | copyValues = false )

inline

Definition at line 164 of file Vector.h.

Referenced by casacore::TableExprNodeSet::toArray().

## shape() [1/2]

template<typename T>

const IPosition & casacore::Vector< T >::shape | ( |  | ) | const

inline

The length of the Vector.

Definition at line 297 of file Vector.h.

## shape() [2/2]

template<typename T>

void casacore::Vector< T >::shape | ( | int & | Shape | ) | const

inline

Definition at line 299 of file Vector.h.

The documentation for this class was generated from the following files:

- casa/Arrays/ArrayFwd.h
- casa/Arrays/Vector.h